
subroutine filter1(x,nel,n,y)

! Apply a boxcar filter n+1 pixels wide to a vector x.
!
!
!	IN:	x	Input vector
!		nel	number of points in the input vectors
!		n	n/2 pixels will be used on each side for even n
!					if not, n/2+1 on the left, 
!					and n/2 on the right
!	
!	OUT:	y	Output vector
!

use share, only: dp

implicit none

!input/output
integer, intent(in)	:: nel,n
real(dp), intent(in)	:: x(nel)	  !input vector (data)
real(dp), intent(out)	:: y(nel)	  !output vectors (smoothed data)

!locals
integer			:: j,i1,i2,taco,n2t,n2

taco=0
if (n/2. > floor(n/2.)) taco=1
n2=n/2
n2t=n2+taco

do j=1,nel
	i1=max(j-n2t,1)
	i2=min(j+n2,nel)
	y(j)=sum(x(i1:i2))/(i2-i1+1._dp)
	!write(*,*)j,i1,i2,x(i1:i2),y(j)
enddo

end subroutine filter1
