MODULE fun

implicit none

contains

SUBROUTINE objfun(w, pf, pf0, obs, lambda_obs, mobs, lsfarr, p, func)
 
use share, only: dp,ndim,nov,indv,                    &
                 ntie,indtie,typetie,ttie0,ttie,      &
                 nlambda1,mlsf,nlsf,                  &
                 trkout
				
implicit none
 
!in/out
real(dp), intent(in)	:: w(nlambda1)		! weights
real(dp), intent(inout)	:: pf(ndim)		! vector of fixed parameters
real(dp), intent(in)    :: pf0(ndim)            ! params read from pffile
						! (in physical units)
real(dp), intent(in)	:: obs(nlambda1)	! vector of observations
real(dp), intent(in)	:: lambda_obs(nlambda1)	! vector of observations
real(dp), intent(in)    :: mobs             ! mean or median of obs array
real(dp), intent(in)    :: lsfarr(mlsf,nlsf)    ! lsfarray
real (dp), intent(in)   :: p(nov)
real (dp), intent(out)  :: func
                                                                                
!locals
real (dp)               :: pp(ndim) 
real (dp)               :: pphys(ndim)          !pp in physical units
integer                 :: i,ii,jj,kk,offset
real(dp)		:: flux(nlambda1)	!interpolated flux vector

pp=pf

!write(*,*)'hola'
do i=1,nov
        pp(indv(i))=p(i)
        !write(*,*)i,p(i)
enddo

if (indtie(1) > 0) then
	pphys(1:ndim)=pp(1:ndim)  
	call physical(pphys)
	if (typetie == 0) then
	  do i=1,ntie
		pphys(indtie(i))=ttie0(i)+sum(ttie(i,1:ndim)*pphys(1:ndim))
	  enddo
	else
	  pphys(1:ndim)=pphys(1:ndim)-pf0(1:ndim)
          do i=1,ntie
                pphys(indtie(i))=ttie0(i)+sum(ttie(i,1:ndim)*pphys(1:ndim))
          enddo
	endif
	call normal(pphys)
	pp(1:ndim)=pphys(1:ndim)
endif

!write(*,*)'pp=',pp
                                                                                
!evaluate lchi
call flx(pp,lambda_obs,mobs,lsfarr,flux)
func=0.0_dp
func=sum(w*(obs(1:nlambda1)-flux(1:nlambda1))**2)
                                                                                
func=func/50._dp
                                                                                
!write(*,*)'exiting objfun',pp
pf=pp

if (trkout /= 0) then
	if (abs(trkout) == 1) then
		write(11,*) pp
	else 
        	pphys(1:ndim)=pp(1:ndim)
        	call physical(pphys)
		write(11,*) pphys
	endif
	if (trkout < 0) write(12,'(200000(es12.5,1x))') w*(obs-flux)
endif

END SUBROUTINE objfun

END MODULE fun
